(in-package #:odo/model-api)

(defsection @odo/model-api/state-variable (:title "State Variables")
  "State variables represent a single variable whose value changes over
time. Conceptually, they are also a function with one input (time)."
  (odo:state-variable class)
  (odo:odo-state-variable class)
  (odo:state-variable-p generic-function)
  (odo:odo-state-variable-p generic-function)
  "#### Constructors"
  (odo:make-state-variable function)
  "#### Properties"
  "In addition to the `@ODO/MODEL-API/ANNOTATION` API, state variables respond
to:"
  (odo:state-variable-name generic-function)
  (odo:state-variable-uncontrollable-p generic-function)
  (odo:state-variable-conditional-p generic-function)
  (odo:range generic-function)
  (odo:range-at generic-function)
  (odo:state-variable-range generic-function)
  (odo:state-variable-range-at generic-function)
  (odo:state-variable-time-domain generic-function))


;;; Types

(defclass odo:state-variable (odo:object)
  ()
  (:documentation
   "A state variable. The object responds to:

+ `ODO-STATE-VARIABLE-P` with T
+ `NAME`
+ `STATE-VARIABLE-UNCONTROLLABLE-P`
+ `STATE-VARIABLE-CONDITIONAL-P`
+ `STATE-VARIABLE-RANGE`
+ `STATE-VARIABLE-RANGE-AT`
+ `STATE-VARIABLE-TIME-DOMAIN`"))

(utils:define-renamed-class odo:odo-state-variable odo:state-variable)

(defgeneric odo:state-variable-p (obj)
  (:documentation
   "Returns T iff `OBJ` is an Odo state variable.")
  (:method ((obj t))
    nil))

(utils:define-renamed-generic (odo:odo-state-variable-p odo:state-variable-p) (obj))


;;; State Variable API

(utils:define-renamed-generic (odo:state-variable-name odo:name) (state-variable))

(utils:define-renamed-generic (odo:state-variable-uncontrollable-p odo:uncontrollable-p) (state-variable))

(utils:define-renamed-generic (odo:state-variable-conditional-p odo:conditional-p) (state-variable))

(defgeneric odo:range (state-variable)
  (:documentation
   "Returns an odo domain representing all the values that `STATE-VARIABLE` can
possibly take (regardless of time)."))

(utils:define-renamed-generic (odo:state-variable-range odo:range :redirect t) (state-variable))

(defgeneric odo:range-at (state-variable time)
  (:documentation
   "Returns an odo domain representing all the values that `STATE-VARIABLE` can
possibly take at `TIME`."))

(utils:define-renamed-generic (odo:state-variable-range-at odo:range-at :redirect t) (state-variable time))

(defgeneric odo:state-variable-time-domain (state-variable)
  (:documentation
   "Returns an odo domain representing the time over which the state variable is
defined."))


;;; Constructors

(defun odo:make-state-variable (range-or-spec
                                &rest
                                  args
                                &key
                                  (time-domain-or-spec '((real 0 *)))
                                  (name (gensym))
                                  conditional-p
                                  uncontrollable-p
                                  annotations)
  "Instantiate and return a new state variable.

If `RANGE-OR-SPEC` is an `ODO-DOMAIN`, then it is used as a template to
instantiate this state variable. Note that implementations are *not* allowed to
just reference `RANGE-OR-SPEC`; it must be copied.

If `RANGE-OR-SPEC` is not an `ODO-DOMAIN`, then it must be a list of arguments
suitable for `MAKE-DOMAIN`.

`TIME-DOMAIN-OR-SPEC` is treated similarly to `RANGE-OR-SPEC` and describes the
time over which the state variable is defined.

If `NAME` is not supplied, a name is autogenerated.

If `UNCONTROLLABLE-P` is T, the state variable is uncontrollable.

If `CONDITIONAL-P` is T, the state variable is conditional."
  (declare (ignore annotations conditional-p uncontrollable-p))
  (let ((range (if (odo:domain-p range-or-spec)
                   range-or-spec
                   (apply #'odo:make-domain range-or-spec)))
        (time-domain (if (odo:domain-p time-domain-or-spec)
                         time-domain-or-spec
                         (apply #'odo:make-domain time-domain-or-spec))))
    (apply #'odo:make-instance
           'odo:state-variable
           :range range
           :time-domain time-domain
           :name name
           (alex:remove-from-plist args :time-domain-or-spec :name))))


;;; Copying

(defmethod odo:copy-by-type (self (type odo:state-variable) &key context)
  (or (funcall (utils:odo-copy-context-var-map-fun context) self)
      (odo:make-state-variable (odo:copy (odo:range self) :context context)
                               :time-domain-or-spec (odo:copy (odo:state-variable-time-domain self) :context context)
                               :name (odo:name self)
                               :conditional-p (odo:conditional-p self)
                               :uncontrollable-p (odo:uncontrollable-p self)
                               :annotations (copy-list (odo:annotation-plist self)))))
